searchNodes=[{"doc":"Verk is a job processing system that integrates well with Sidekiq jobs. Each queue will have a pool of workers handled by poolboy that will process jobs. Verk has a retry mechanism similar to Sidekiq that keeps retrying the jobs with a reasonable backoff. It has an API that provides information about the queues.","ref":"Verk.html","title":"Verk","type":"module"},{"doc":"Add a new queue with a pool of size size of workers.","ref":"Verk.html#add_queue/2","title":"Verk.add_queue/2","type":"function"},{"doc":"Enqueues a Job to the specified queue returning the respective job id. The job must have: a valid queue a list of args to perform a module to perform ( class ) a valid jid Optionally a Redix server can be passed which defaults to Verk.Redis .","ref":"Verk.html#enqueue/2","title":"Verk.enqueue/2","type":"function"},{"doc":"See Verk.Manager.pause/1 .","ref":"Verk.html#pause_queue/1","title":"Verk.pause_queue/1","type":"function"},{"doc":"Remove queue from the list of queues that are being processed.","ref":"Verk.html#remove_queue/1","title":"Verk.remove_queue/1","type":"function"},{"doc":"See Verk.Manager.resume/1 .","ref":"Verk.html#resume_queue/1","title":"Verk.resume_queue/1","type":"function"},{"doc":"Schedules a Job to the specified queue returning the respective job id. The job must have: a valid queue a list of args to perform a module to perform ( class ) a valid jid Optionally a Redix server can be passed which defaults to Verk.Redis .","ref":"Verk.html#schedule/3","title":"Verk.schedule/3","type":"function"},{"doc":"This module interacts with jobs in the dead set. Set config :verk, max_dead_jobs: value on your config file to set the max amount of dead jobs to be stored on your dead queue. Defaults at 100 .","ref":"Verk.DeadSet.html","title":"Verk.DeadSet","type":"module"},{"doc":"Adds a job to the dead set ordering by timestamp . Optionally a redis connection can be specified.","ref":"Verk.DeadSet.html#add/3","title":"Verk.DeadSet.add/3","type":"function"},{"doc":"Adds a job to the dead set ordering by timestamp , raising if there's an error. Optionally a redis connection can be specified.","ref":"Verk.DeadSet.html#add!/3","title":"Verk.DeadSet.add!/3","type":"function"},{"doc":"Clears the dead set.","ref":"Verk.DeadSet.html#clear/1","title":"Verk.DeadSet.clear/1","type":"function"},{"doc":"Clears the dead set, raising if there's an error.","ref":"Verk.DeadSet.html#clear!/1","title":"Verk.DeadSet.clear!/1","type":"function"},{"doc":"Counts how many jobs are inside the dead set.","ref":"Verk.DeadSet.html#count/1","title":"Verk.DeadSet.count/1","type":"function"},{"doc":"Counts how many jobs are inside the dead set, raising if there's an error.","ref":"Verk.DeadSet.html#count!/1","title":"Verk.DeadSet.count!/1","type":"function"},{"doc":"Delete the job from the dead set.","ref":"Verk.DeadSet.html#delete_job/2","title":"Verk.DeadSet.delete_job/2","type":"function"},{"doc":"Delete the job from the dead set, raising if there's an exception.","ref":"Verk.DeadSet.html#delete_job!/2","title":"Verk.DeadSet.delete_job!/2","type":"function"},{"doc":"Redis dead set key.","ref":"Verk.DeadSet.html#key/0","title":"Verk.DeadSet.key/0","type":"function"},{"doc":"List jobs from start to stop .","ref":"Verk.DeadSet.html#range/3","title":"Verk.DeadSet.range/3","type":"function"},{"doc":"List jobs from start to stop , raising if there's an error.","ref":"Verk.DeadSet.html#range!/3","title":"Verk.DeadSet.range!/3","type":"function"},{"doc":"A GenStage producer that broadcasts events to subscribed consumers.","ref":"Verk.EventProducer.html","title":"Verk.EventProducer","type":"module"},{"doc":"","ref":"Verk.EventProducer.html#async_notify/1","title":"Verk.EventProducer.async_notify/1","type":"function"},{"doc":"Callback implementation for GenStage.handle_cast/2 .","ref":"Verk.EventProducer.html#handle_cast/2","title":"Verk.EventProducer.handle_cast/2","type":"function"},{"doc":"Callback implementation for GenStage.handle_demand/2 .","ref":"Verk.EventProducer.html#handle_demand/2","title":"Verk.EventProducer.handle_demand/2","type":"function"},{"doc":"Callback implementation for GenStage.init/1 .","ref":"Verk.EventProducer.html#init/1","title":"Verk.EventProducer.init/1","type":"function"},{"doc":"","ref":"Verk.EventProducer.html#start_link/0","title":"Verk.EventProducer.start_link/0","type":"function"},{"doc":"","ref":"Verk.EventProducer.html#stop/0","title":"Verk.EventProducer.stop/0","type":"function"},{"doc":"Events generated while jobs are being processed.","ref":"Verk.Events.html","title":"Verk.Events","type":"module"},{"doc":"When a job fails this event is generated.","ref":"Verk.Events.JobFailed.html","title":"Verk.Events.JobFailed","type":"module"},{"doc":"","ref":"Verk.Events.JobFailed.html#t:t/0","title":"Verk.Events.JobFailed.t/0","type":"type"},{"doc":"When a job finishes this event is generated.","ref":"Verk.Events.JobFinished.html","title":"Verk.Events.JobFinished","type":"module"},{"doc":"","ref":"Verk.Events.JobFinished.html#t:t/0","title":"Verk.Events.JobFinished.t/0","type":"type"},{"doc":"When a job starts this event is generated.","ref":"Verk.Events.JobStarted.html","title":"Verk.Events.JobStarted","type":"module"},{"doc":"","ref":"Verk.Events.JobStarted.html#t:t/0","title":"Verk.Events.JobStarted.t/0","type":"type"},{"doc":"When a queue paused.","ref":"Verk.Events.QueuePaused.html","title":"Verk.Events.QueuePaused","type":"module"},{"doc":"","ref":"Verk.Events.QueuePaused.html#t:t/0","title":"Verk.Events.QueuePaused.t/0","type":"type"},{"doc":"When a queue is pausing.","ref":"Verk.Events.QueuePausing.html","title":"Verk.Events.QueuePausing","type":"module"},{"doc":"","ref":"Verk.Events.QueuePausing.html#t:t/0","title":"Verk.Events.QueuePausing.t/0","type":"type"},{"doc":"When a queue is running.","ref":"Verk.Events.QueueRunning.html","title":"Verk.Events.QueueRunning","type":"module"},{"doc":"","ref":"Verk.Events.QueueRunning.html#t:t/0","title":"Verk.Events.QueueRunning.t/0","type":"type"},{"doc":"This module interacts with the in progress queue.","ref":"Verk.InProgressQueue.html","title":"Verk.InProgressQueue","type":"module"},{"doc":"","ref":"Verk.InProgressQueue.html#enqueue_in_progress/3","title":"Verk.InProgressQueue.enqueue_in_progress/3","type":"function"},{"doc":"The Job struct. Set config :verk, max_retry_count: value on your config file to set the default max amount of retries on all your Verk.Job when none is informed. Defaults at 25 .","ref":"Verk.Job.html","title":"Verk.Job","type":"module"},{"doc":"Decode the JSON payload storing the original json as part of the struct.","ref":"Verk.Job.html#decode/1","title":"Verk.Job.decode/1","type":"function"},{"doc":"Decode the JSON payload storing the original json as part of the struct, raising if there is an error","ref":"Verk.Job.html#decode!/1","title":"Verk.Job.decode!/1","type":"function"},{"doc":"","ref":"Verk.Job.html#default_max_retry_count/0","title":"Verk.Job.default_max_retry_count/0","type":"function"},{"doc":"Encode the struct to a JSON string, raising if there is an error","ref":"Verk.Job.html#encode!/1","title":"Verk.Job.encode!/1","type":"function"},{"doc":"","ref":"Verk.Job.html#t:t/0","title":"Verk.Job.t/0","type":"type"},{"doc":"Helper module to log when a job starts, fails or finishes.","ref":"Verk.Log.html","title":"Verk.Log","type":"module"},{"doc":"","ref":"Verk.Log.html#done/3","title":"Verk.Log.done/3","type":"function"},{"doc":"","ref":"Verk.Log.html#fail/3","title":"Verk.Log.fail/3","type":"function"},{"doc":"","ref":"Verk.Log.html#start/2","title":"Verk.Log.start/2","type":"function"},{"doc":"A process that manages the state of each started queue.","ref":"Verk.Manager.html","title":"Verk.Manager","type":"module"},{"doc":"It adds the queue running with the amount of size of workers. It always returns the child spec.","ref":"Verk.Manager.html#add/2","title":"Verk.Manager.add/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.Manager.html#child_spec/1","title":"Verk.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Verk.Manager.html#pause/1","title":"Verk.Manager.pause/1","type":"function"},{"doc":"It removes the queue . It returns :ok if successful and {:error, :not_found} otherwise.","ref":"Verk.Manager.html#remove/1","title":"Verk.Manager.remove/1","type":"function"},{"doc":"","ref":"Verk.Manager.html#resume/1","title":"Verk.Manager.resume/1","type":"function"},{"doc":"It returns the status of each queue currently. [{:default, 25, :paused}, {:low_priority, 10, :running}]","ref":"Verk.Manager.html#status/0","title":"Verk.Manager.status/0","type":"function"},{"doc":"It returns the status of each queue currently. [{:default, 25, :paused}, {:low_priority, 10, :running}]","ref":"Verk.Manager.html#status/1","title":"Verk.Manager.status/1","type":"function"},{"doc":"Node data controller.","ref":"Verk.Node.html","title":"Verk.Node","type":"module"},{"doc":"Redis command to add a queue to the set of queues that a node is processing. iex&gt; Verk.Node . add_node_redis_command ( &quot;123&quot; ) [ &quot;SADD&quot; , &quot;verk_nodes&quot; , &quot;123&quot; ]","ref":"Verk.Node.html#add_node_redis_command/1","title":"Verk.Node.add_node_redis_command/1","type":"function"},{"doc":"Redis command to add a queue to the set of queues that a node is processing. iex&gt; Verk.Node . add_queue_redis_command ( &quot;123&quot; , &quot;default&quot; ) [ &quot;SADD&quot; , &quot;verk:node:123:queues&quot; , &quot;default&quot; ]","ref":"Verk.Node.html#add_queue_redis_command/2","title":"Verk.Node.add_queue_redis_command/2","type":"function"},{"doc":"","ref":"Verk.Node.html#deregister!/2","title":"Verk.Node.deregister!/2","type":"function"},{"doc":"","ref":"Verk.Node.html#expire_in/3","title":"Verk.Node.expire_in/3","type":"function"},{"doc":"","ref":"Verk.Node.html#members/3","title":"Verk.Node.members/3","type":"function"},{"doc":"","ref":"Verk.Node.html#queues!/4","title":"Verk.Node.queues!/4","type":"function"},{"doc":"","ref":"Verk.Node.html#ttl!/2","title":"Verk.Node.ttl!/2","type":"function"},{"doc":"NodeManager keeps track of the nodes that are working on the queues.","ref":"Verk.Node.Manager.html","title":"Verk.Node.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.Node.Manager.html#child_spec/1","title":"Verk.Node.Manager.child_spec/1","type":"function"},{"doc":"This module interacts with a queue.","ref":"Verk.Queue.html","title":"Verk.Queue","type":"module"},{"doc":"Clears the queue It will return {:ok, true} if the queue was cleared and {:ok, false} otherwise. An error tuple may be returned if Redis failed.","ref":"Verk.Queue.html#clear/1","title":"Verk.Queue.clear/1","type":"function"},{"doc":"Clears the queue , raising if there's an error. It will return true if the queue was cleared and false otherwise.","ref":"Verk.Queue.html#clear!/1","title":"Verk.Queue.clear!/1","type":"function"},{"doc":"Counts how many jobs are enqueued on a queue.","ref":"Verk.Queue.html#count/1","title":"Verk.Queue.count/1","type":"function"},{"doc":"Counts how many jobs are enqueued on a queue, raising if there's an error.","ref":"Verk.Queue.html#count!/1","title":"Verk.Queue.count!/1","type":"function"},{"doc":"Deletes the job from the queue . It returns {:ok, true} if the job was found and deleted. Otherwise it returns {:ok, false} . An error tuple may be returned if Redis failed.","ref":"Verk.Queue.html#delete_job/2","title":"Verk.Queue.delete_job/2","type":"function"},{"doc":"Delete job from the queue , raising if there's an error. It returns true if the job was found and delete. Otherwise it returns false . An error will be raised if Redis failed.","ref":"Verk.Queue.html#delete_job!/2","title":"Verk.Queue.delete_job!/2","type":"function"},{"doc":"Lists enqueued jobs from start to stop .","ref":"Verk.Queue.html#range/3","title":"Verk.Queue.range/3","type":"function"},{"doc":"Lists enqueued jobs from start to stop , raising if there's an error.","ref":"Verk.Queue.html#range!/3","title":"Verk.Queue.range!/3","type":"function"},{"doc":"Supervisor definition for a queue. It consists of: A Verk.QueueManager A poolboy pool of workers A Verk.WorkersManager","ref":"Verk.Queue.Supervisor.html","title":"Verk.Queue.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.Queue.Supervisor.html#child_spec/1","title":"Verk.Queue.Supervisor.child_spec/1","type":"function"},{"doc":"QueueManager interacts with redis to dequeue jobs from the specified queue.","ref":"Verk.QueueManager.html","title":"Verk.QueueManager","type":"module"},{"doc":"Acknowledges that a job was processed.","ref":"Verk.QueueManager.html#ack/2","title":"Verk.QueueManager.ack/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.QueueManager.html#child_spec/1","title":"Verk.QueueManager.child_spec/1","type":"function"},{"doc":"Pop a job from the assigned queue and reply with it if not empty.","ref":"Verk.QueueManager.html#dequeue/3","title":"Verk.QueueManager.dequeue/3","type":"function"},{"doc":"Enqueues inprogress jobs back to the queue.","ref":"Verk.QueueManager.html#enqueue_inprogress/1","title":"Verk.QueueManager.enqueue_inprogress/1","type":"function"},{"doc":"Connects to redis.","ref":"Verk.QueueManager.html#init/1","title":"Verk.QueueManager.init/1","type":"function"},{"doc":"Removes a malformed job from the inprogress queue.","ref":"Verk.QueueManager.html#malformed/2","title":"Verk.QueueManager.malformed/2","type":"function"},{"doc":"Returns the atom that represents the QueueManager of the queue .","ref":"Verk.QueueManager.html#name/1","title":"Verk.QueueManager.name/1","type":"function"},{"doc":"Add job to be retried in the assigned queue.","ref":"Verk.QueueManager.html#retry/5","title":"Verk.QueueManager.retry/5","type":"function"},{"doc":"This process will update an :ets table with the following information per queue: Current amount of running jobs Amount of finished jobs Amount of failed jobs It will persist to redis from time to time. It also holds information about the current status of queus. They can be: running idle pausing paused","ref":"Verk.QueueStats.html","title":"Verk.QueueStats","type":"module"},{"doc":"Lists the queues and their stats searching for a prefix if provided.","ref":"Verk.QueueStats.html#all/1","title":"Verk.QueueStats.all/1","type":"function"},{"doc":"Callback implementation for GenStage.handle_call/3 .","ref":"Verk.QueueStats.html#handle_call/3","title":"Verk.QueueStats.handle_call/3","type":"function"},{"doc":"Callback implementation for GenStage.handle_events/3 .","ref":"Verk.QueueStats.html#handle_events/3","title":"Verk.QueueStats.handle_events/3","type":"function"},{"doc":"This module is responsible for abstracting the logic of keeping counters for each queue.","ref":"Verk.QueueStatsCounters.html","title":"Verk.QueueStatsCounters","type":"module"},{"doc":"It outputs the current stats about each queue and total and search for a prefix if provided.","ref":"Verk.QueueStatsCounters.html#all/1","title":"Verk.QueueStatsCounters.all/1","type":"function"},{"doc":"Initializes the ets tables for the queue stats.","ref":"Verk.QueueStatsCounters.html#init/0","title":"Verk.QueueStatsCounters.init/0","type":"function"},{"doc":"Saves processed and failed total counts to Redis.","ref":"Verk.QueueStatsCounters.html#persist/0","title":"Verk.QueueStatsCounters.persist/0","type":"function"},{"doc":"Updates the counters according to the event that happened.","ref":"Verk.QueueStatsCounters.html#register/2","title":"Verk.QueueStatsCounters.register/2","type":"function"},{"doc":"It resets the started counter of a queue .","ref":"Verk.QueueStatsCounters.html#reset_started/1","title":"Verk.QueueStatsCounters.reset_started/1","type":"function"},{"doc":"This process exists to pause queues once a shutdown is issued. Once all queues are paused the process will shutdown.","ref":"Verk.QueuesDrainer.html","title":"Verk.QueuesDrainer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.QueuesDrainer.html#child_spec/1","title":"Verk.QueuesDrainer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Verk.QueuesDrainer.html#init/1","title":"Verk.QueuesDrainer.init/1","type":"function"},{"doc":"","ref":"Verk.QueuesDrainer.html#start_link/1","title":"Verk.QueuesDrainer.start_link/1","type":"function"},{"doc":"This module interacts with jobs in the retry set.","ref":"Verk.RetrySet.html","title":"Verk.RetrySet","type":"module"},{"doc":"Adds a job to the retry set ordering by timestamp . Optionally a redis connection can be specified.","ref":"Verk.RetrySet.html#add/3","title":"Verk.RetrySet.add/3","type":"function"},{"doc":"Adds a job to the retry set ordering by timestamp , raising if there's an error. Optionally a redis connection can be specified.","ref":"Verk.RetrySet.html#add!/3","title":"Verk.RetrySet.add!/3","type":"function"},{"doc":"Clears the retry set. It will return {:ok, true} if the retry set was cleared and {:ok, false} otherwise. An error tuple may be returned if Redis failed.","ref":"Verk.RetrySet.html#clear/1","title":"Verk.RetrySet.clear/1","type":"function"},{"doc":"Clears the retry set, raising if there's an error. It will return true if the retry set was cleared and false otherwise.","ref":"Verk.RetrySet.html#clear!/1","title":"Verk.RetrySet.clear!/1","type":"function"},{"doc":"Counts how many jobs are inside the retry set.","ref":"Verk.RetrySet.html#count/1","title":"Verk.RetrySet.count/1","type":"function"},{"doc":"Counts how many jobs are inside the retry set, raising if there's an error.","ref":"Verk.RetrySet.html#count!/1","title":"Verk.RetrySet.count!/1","type":"function"},{"doc":"Delete the job from the retry set. It returns {:ok, true} if the job was found and deleted. Otherwise it returns {:ok, false} . An error tuple may be returned if Redis failed.","ref":"Verk.RetrySet.html#delete_job/2","title":"Verk.RetrySet.delete_job/2","type":"function"},{"doc":"Delete the job from the retry set, raising if there's an error. It returns true if the job was found and delete. Otherwise it returns false .","ref":"Verk.RetrySet.html#delete_job!/2","title":"Verk.RetrySet.delete_job!/2","type":"function"},{"doc":"Redis retry set key.","ref":"Verk.RetrySet.html#key/0","title":"Verk.RetrySet.key/0","type":"function"},{"doc":"List jobs from start to stop .","ref":"Verk.RetrySet.html#range/3","title":"Verk.RetrySet.range/3","type":"function"},{"doc":"List jobs from start to stop , raising if there's an error.","ref":"Verk.RetrySet.html#range!/3","title":"Verk.RetrySet.range!/3","type":"function"},{"doc":"List jobs from start to stop including their scores.","ref":"Verk.RetrySet.html#range_with_score/3","title":"Verk.RetrySet.range_with_score/3","type":"function"},{"doc":"List jobs from start to stop including their scores, raising if there's an error.","ref":"Verk.RetrySet.html#range_with_score!/3","title":"Verk.RetrySet.range_with_score!/3","type":"function"},{"doc":"Move the job out of the retry set to be retried immediately. It returns {:ok, true} if the job was found and requeued. Otherwise it returns {:ok, false} . An error tuple may be returned if Redis failed.","ref":"Verk.RetrySet.html#requeue_job/2","title":"Verk.RetrySet.requeue_job/2","type":"function"},{"doc":"Move the job out of the retry set to be retried immediately, raising if there's an error. It returns true if the job was found and requeued. Otherwise it returns false .","ref":"Verk.RetrySet.html#requeue_job!/2","title":"Verk.RetrySet.requeue_job!/2","type":"function"},{"doc":"The ScheduleManager looks for jobs to be retried and accept jobs to scheduled to be retried. The job is added back to the queue when it's ready to be run or retried.","ref":"Verk.ScheduleManager.html","title":"Verk.ScheduleManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.ScheduleManager.html#child_spec/1","title":"Verk.ScheduleManager.child_spec/1","type":"function"},{"doc":"Search for scheduled jobs to be done and if removal succeeds enqueue the job.","ref":"Verk.ScheduleManager.html#handle_info/2","title":"Verk.ScheduleManager.handle_info/2","type":"function"},{"doc":"Connect to redis and timeout with the poll_interval .","ref":"Verk.ScheduleManager.html#init/1","title":"Verk.ScheduleManager.init/1","type":"function"},{"doc":"Provides helpers to load Lua scripts into Redis and calculate SHA1.","ref":"Verk.Scripts.html","title":"Verk.Scripts","type":"module"},{"doc":"","ref":"Verk.Scripts.html#load/1","title":"Verk.Scripts.load/1","type":"function"},{"doc":"","ref":"Verk.Scripts.html#sha/1","title":"Verk.Scripts.sha/1","type":"function"},{"doc":"This module interacts with the jobs on a sorted set.","ref":"Verk.SortedSet.html","title":"Verk.SortedSet","type":"module"},{"doc":"Clears the sorted set. It will return {:ok, true} if the sorted set was cleared and {:ok, false} otherwise. An error tuple may be returned if Redis failed.","ref":"Verk.SortedSet.html#clear/2","title":"Verk.SortedSet.clear/2","type":"function"},{"doc":"Clears the sorted set, raising if there's an error. It will return true if the sorted set was cleared and false otherwise.","ref":"Verk.SortedSet.html#clear!/2","title":"Verk.SortedSet.clear!/2","type":"function"},{"doc":"Counts how many jobs are inside the sorted set.","ref":"Verk.SortedSet.html#count/2","title":"Verk.SortedSet.count/2","type":"function"},{"doc":"Counts how many jobs are inside the sorted set, raising if there's an error.","ref":"Verk.SortedSet.html#count!/2","title":"Verk.SortedSet.count!/2","type":"function"},{"doc":"Deletes the job from the sorted set. It returns {:ok, true} if the job was found and deleted. Otherwise it returns {:ok, false} . An error tuple may be returned if Redis failed.","ref":"Verk.SortedSet.html#delete_job/3","title":"Verk.SortedSet.delete_job/3","type":"function"},{"doc":"Deletes the job from the sorted set, raising if there's an error. It returns true if the job was found and delete. Otherwise it returns false .","ref":"Verk.SortedSet.html#delete_job!/3","title":"Verk.SortedSet.delete_job!/3","type":"function"},{"doc":"Lists jobs from start to stop .","ref":"Verk.SortedSet.html#range/4","title":"Verk.SortedSet.range/4","type":"function"},{"doc":"Lists jobs from start to stop , raising if there's an error.","ref":"Verk.SortedSet.html#range!/4","title":"Verk.SortedSet.range!/4","type":"function"},{"doc":"Lists jobs from start to stop along with the item scores.","ref":"Verk.SortedSet.html#range_with_score/4","title":"Verk.SortedSet.range_with_score/4","type":"function"},{"doc":"Lists jobs from start to stop along with the item scores, raising if there's an error.","ref":"Verk.SortedSet.html#range_with_score!/4","title":"Verk.SortedSet.range_with_score!/4","type":"function"},{"doc":"Moves the job from the sorted set back to its original queue. It returns {:ok, true} if the job was found and requeued. Otherwise it returns {:ok, false} . An error tuple may be returned if Redis failed.","ref":"Verk.SortedSet.html#requeue_job/3","title":"Verk.SortedSet.requeue_job/3","type":"function"},{"doc":"Moves the job from the sorted set back to its original queue, raising if there's an error. It returns true if the job was found and requeued. Otherwise it returns false .","ref":"Verk.SortedSet.html#requeue_job!/3","title":"Verk.SortedSet.requeue_job!/3","type":"function"},{"doc":"Basic stats for Verk.","ref":"Verk.Stats.html","title":"Verk.Stats","type":"module"},{"doc":"Total amount of processed and failed jobs for a single queue.","ref":"Verk.Stats.html#queue_total/2","title":"Verk.Stats.queue_total/2","type":"function"},{"doc":"Total amount of processed and failed jobs.","ref":"Verk.Stats.html#total/1","title":"Verk.Stats.total/1","type":"function"},{"doc":"Supervisor definition for Verk application. It consists of: Verk.ScheduleManager GenStage producer named Verk.EventProducer GenStage consumer Verk.QueueStats Redis connectionn named Verk.Redis A Verk.Queue.Supervisor per queue","ref":"Verk.Supervisor.html","title":"Verk.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.Supervisor.html#child_spec/1","title":"Verk.Supervisor.child_spec/1","type":"function"},{"doc":"It starts the main supervisor","ref":"Verk.Supervisor.html#start_link/1","title":"Verk.Supervisor.start_link/1","type":"function"},{"doc":"Internal API for time management and comparison functions.","ref":"Verk.Time.html","title":"Verk.Time","type":"module"},{"doc":"Returns true if the first argument occurred after the second argument.","ref":"Verk.Time.html#after?/2","title":"Verk.Time.after?/2","type":"function"},{"doc":"Returns the number of indicated units that separate the two timestamps. A positive result indicates that datetime2 occurred after datetime1 .","ref":"Verk.Time.html#diff/3","title":"Verk.Time.diff/3","type":"function"},{"doc":"Moves DateTime supplied the indicated amount of time. Supported units are those specified by System.time_unit","ref":"Verk.Time.html#shift/3","title":"Verk.Time.shift/3","type":"function"},{"doc":"Worker executes the job, messages the manager when it's done and shutdowns.","ref":"Verk.Worker.html","title":"Verk.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.Worker.html#child_spec/1","title":"Verk.Worker.child_spec/1","type":"function"},{"doc":"Get the current job that the worker is running.","ref":"Verk.Worker.html#current_job/0","title":"Verk.Worker.current_job/0","type":"function"},{"doc":"Ask the worker to perform the job.","ref":"Verk.Worker.html#perform_async/3","title":"Verk.Worker.perform_async/3","type":"function"},{"doc":"A WorkersManager assigns jobs to workers from a pool (handled by poolboy) monitoring the job.. It interacts with the related QueueManager to request jobs and to schedule jobs to be retried.","ref":"Verk.WorkersManager.html","title":"Verk.WorkersManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Verk.WorkersManager.html#child_spec/1","title":"Verk.WorkersManager.child_spec/1","type":"function"},{"doc":"Create a table to monitor workers saving data about the assigned queue/pool.","ref":"Verk.WorkersManager.html#init/1","title":"Verk.WorkersManager.init/1","type":"function"},{"doc":"List information about the process that is currently running a job_id .","ref":"Verk.WorkersManager.html#inspect_worker/2","title":"Verk.WorkersManager.inspect_worker/2","type":"function"},{"doc":"Returns the atom that represents the WorkersManager of the queue .","ref":"Verk.WorkersManager.html#name/1","title":"Verk.WorkersManager.name/1","type":"function"},{"doc":"Pauses a queue .","ref":"Verk.WorkersManager.html#pause/1","title":"Verk.WorkersManager.pause/1","type":"function"},{"doc":"Resumes a queue .","ref":"Verk.WorkersManager.html#resume/1","title":"Verk.WorkersManager.resume/1","type":"function"},{"doc":"List running jobs. Example [ %{ process : # PID &lt; 0 . 186 . 0 &gt; , job : % Verk.Job { ... } , started_at : % DateTime { ... } } ]","ref":"Verk.WorkersManager.html#running_jobs/2","title":"Verk.WorkersManager.running_jobs/2","type":"function"},{"doc":"Copyright (c) 2013 Eduardo Gurgel Pinho Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Verk is a job processing system backed by Redis. It uses the same job definition of Sidekiq/Resque. The goal is to be able to isolate the execution of a queue of jobs as much as possible. Every queue has its own supervision tree: A pool of workers; A QueueManager that interacts with Redis to get jobs and enqueue them back to be retried if necessary; A WorkersManager that will interact with the QueueManager and the pool to execute jobs. Verk will hold one connection to Redis per queue plus one dedicated to the ScheduleManager and one general connection for other use cases like deleting a job from retry set or enqueuing new jobs. The ScheduleManager fetches jobs from the retry set to be enqueued back to the original queue when it's ready to be retried. It also has one GenStage producer called Verk.EventProducer . The image below is an overview of Verk's supervision tree running with a queue named default having 5 workers. Feature set: Retry mechanism with exponential backoff Dynamic addition/removal of queues Reliable job processing (RPOPLPUSH and Lua scripts to the rescue) Error and event tracking","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"First, add :verk to your mix.exs dependencies: def deps do [ { :verk , &quot;~&gt; 1.0&quot; } ] end and run $ mix deps.get . Add :verk to your applications list if your Elixir version is 1.3 or lower: def application do [ applications : [ :verk ] ] end Add Verk.Supervisor to your supervision tree: defmodule Example.App do use Application def start ( _type , _args ) do import Supervisor.Spec tree = [ supervisor ( Verk.Supervisor , [ ] ) ] opts = [ name : Simple.Sup , strategy : :one_for_one ] Supervisor . start_link ( tree , opts ) end end Finally we need to configure how Verk will process jobs.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Example configuration for Verk having 2 queues: default and priority The queue default will have a maximum of 25 jobs being processed at a time and priority just 10. config :verk , queues : [ default : 25 , priority : 10 ] , max_retry_count : 10 , max_dead_jobs : 100 , poll_interval : 5000 , start_job_log_level : :info , done_job_log_level : :info , fail_job_log_level : :info , node_id : &quot;1&quot; , redis_url : &quot;redis://127.0.0.1:6379&quot; Verk supports the convention {:system, &quot;ENV_NAME&quot;, default} for reading environment configuration at runtime using Confex : config :verk , queues : [ default : 25 , priority : 10 ] , max_retry_count : 10 , max_dead_jobs : 100 , poll_interval : { :system , :integer , &quot;VERK_POLL_INTERVAL&quot; , 5000 } , start_job_log_level : :info , done_job_log_level : :info , fail_job_log_level : :info , node_id : &quot;1&quot; , redis_url : { :system , &quot;VERK_REDIS_URL&quot; , &quot;redis://127.0.0.1:6379&quot; } Now Verk is ready to start processing jobs! :tada:","ref":"readme.html#configuration","title":"Overview - Configuration","type":"extras"},{"doc":"A job is defined by a module and arguments: defmodule ExampleWorker do def perform ( arg1 , arg2 ) do arg1 + arg2 end end This job can be enqueued using Verk.enqueue/1 : Verk . enqueue ( % Verk.Job { queue : :default , class : &quot;ExampleWorker&quot; , args : [ 1 , 2 ] , max_retry_count : 5 } ) This job can also be scheduled using Verk.schedule/2 : perform_at = Timex . shift ( Timex . now , seconds : 30 ) Verk . schedule ( % Verk.Job { queue : :default , class : &quot;ExampleWorker&quot; , args : [ 1 , 2 ] } , perform_at ) Retry at A job can define the function retry_at/2 for custom retry time delay: defmodule ExampleWorker do def perform ( arg1 , arg2 ) do arg1 + arg2 end def retry_at ( failed_at , retry_count ) do failed_at + retry_count end end In this example, the first retry will be scheduled a second later, the second retry will be scheduled two seconds later, and so on. If retry_at/2 is not defined the default exponential backoff is used. Keys in arguments By default, Verk will decode keys in arguments to binary strings. You can change this behavior for jobs enqueued by Verk with the following configuration: config :verk , :args_keys , value The following values are valid: :strings (default) - decodes keys as binary strings :atoms - keys are converted to atoms using String.to_atom/1 :atoms! - keys are converted to atoms using String.to_existing_atom/1","ref":"readme.html#workers","title":"Overview - Workers","type":"extras"},{"doc":"It's possible to dynamically add and remove queues from Verk. Verk . add_queue ( :new , 10 ) # Adds a queue named `new` with 10 workers Verk . remove_queue ( :new ) # Terminate and delete the queue named `new`","ref":"readme.html#queues","title":"Overview - Queues","type":"extras"},{"doc":"The way Verk currently works, there are two pitfalls to pay attention to: Each worker node's node_id MUST be unique. If a node goes online with a node_id , which is already in use by another running node, then the second node will re-enqueue all jobs currently in progress on the first node, which results in jobs executed multiple times. Take caution around removing nodes. If a node with jobs in progress is killed, those jobs will not be restarted until another node with the same node_id comes online. If another node with the same node_id never comes online, the jobs will be stuck forever. This means you should not use dynamic node_id s such as Docker container ids or Kubernetes Deployment pod names. On Heroku Heroku provides an experimental environment variable named after the type and number of the dyno. config :verk , node_id : { :system , &quot;DYNO&quot; , &quot;job.1&quot; } It is possible that two dynos with the same name could overlap for a short time during a dyno restart. As the Heroku documentation says: [...] $DYNO is not guaranteed to be unique within an app. For example, during a deploy or restart, the same dyno identifier could be used for two running dynos. It will be eventually consistent, however. This means that you are still at risk of violating the first rule above on node_id uniqueness. A slightly naive way of lowering the risk would be to add a delay in your application before the Verk queue starts. On Kubernetes We recommend using a StatefulSet to run your pool of workers. StatefulSets add a label, statefulset.kubernetes.io/pod-name , to all its pods with the value {name}-{n} , where {name} is the name of your StatefulSet and {n} is a number from 0 to spec.replicas - 1 . StatefulSets maintain a sticky identity for its pods and guarantee that two identical pods are never up simultaneously. This way it satisfies both of our deployment rules mentioned above. Define your worker like this: # StatefulSets require a service, even though we don't use it directly for anything apiVersion: v1 kind: Service metadata: name: my-worker labels: app: my-worker spec: clusterIP: None selector: app: my-worker --- apiVersion: apps/v1 kind: StatefulSet metadata: name: my-worker labels: app: my-worker spec: selector: matchLabels: app: my-worker serviceName: my-worker # We run two workers in this example replicas: 2 # The workers don't depend on each other, so we can use Parallel pod management podManagementPolicy: Parallel template: metadata: labels: app: my-worker spec: # This should probably match up with the setting you used for Verk's :shutdown_timeout terminationGracePeriodSeconds: 30 containers: - name: my-worker image: my-repo/my-worker env: - name: VERK_NODE_ID valueFrom: fieldRef: fieldPath: metadata.labels['statefulset.kubernetes.io/pod-name'] Notice how we use a fieldRef to expose the pod's statefulset.kubernetes.io/pod-name label as the VERK_NODE_ID environment variable. Instruct Verk to use this environment variable as node_id : config :verk , node_id : { :system , &quot;VERK_NODE_ID&quot; } Be careful when scaling the number of replicas down. Make sure that the pods that will be stopped and never come back do not have any jobs in progress. Scaling up is always safe. Don't use Deployments for pods that will run Verk. If you hardcode node_id into your config, multiple pods with the same node_id will be online at the same time, violating the first rule. If you use a non-sticky environment variable, such as HOSTNAME , you'll violate the second rule and cause jobs to get stuck every time you deploy. If your application serves as e.g. both an API and Verk queue, then it may be wise to run a separate Deployment for your API, which does not run Verk. In that case you can configure your application to check an environment variable, VERK_DISABLED , for whether it should handle any Verk queues: # In your config.exs config :verk , queues : { :system , { MyApp.Env , :verk_queues , [ ] } , &quot;VERK_DISABLED&quot; } # In some other file defmodule MyApp.Env do def verk_queues ( &quot;true&quot; ) , do : { :ok , [ ] } def verk_queues ( _ ) , do : { :ok , [ default : 25 , priority : 10 ] } end Then set VERK_DISABLED=true in your Deployment's spec. EXPERIMENTAL - Generate Node ID Since Verk 1.6.0 there is a new experimental optional configuration generate_node_id . Node IDs are completely controlled automatically by Verk if this configuration is set to true . Under the hood Each time a job is moved to the list of jobs inprogress of a queue this node is added to verk_nodes ( SADD verk_nodes node_id ) and the queue is added to verk:node:\#{node_id}:queues ( SADD verk:node:123:queues queue_name ) Each frequency milliseconds we set the node key to expire in 2 frequency `PSETEX verk:node:\#{node_id} 2 frequency alive` Each frequency milliseconds check for all the keys of all nodes ( verk_nodes ). If the key expired it means that this node is dead and it needs to have its jobs restored. To restore we go through all the running queues ( verk:node:\#{node_id}:queues ) of that node and enqueue them from inprogress back to the queue. Each &quot;enqueue back from in progress&quot; is atomic (&lt;3 Lua) so we won't have duplicates. Configuration The default frequency is 30_000 milliseconds but it can be changed by setting the configuration key heartbeat . config :verk , queues : [ default : 5 , priority : 5 ] , redis_url : &quot;redis://127.0.0.1:6379&quot; , generate_node_id : true , heartbeat : 30_000 ,","ref":"readme.html#deployment","title":"Overview - Deployment","type":"extras"},{"doc":"Verk's goal is to never have a job that exists only in memory. It uses Redis as the single source of truth to retry and track jobs that were being processed if some crash happened. Verk will re-enqueue jobs if the application crashed while jobs were running. It will also retry jobs that failed keeping track of the errors that happened. The jobs that will run on top of Verk should be idempotent as they may run more than once.","ref":"readme.html#reliability","title":"Overview - Reliability","type":"extras"},{"doc":"One can track when jobs start and finish or fail. This can be useful to build metrics around the jobs. The QueueStats handler does some kind of metrics using these events: https://github.com/edgurgel/verk/blob/master/lib/verk/queue_stats.ex Verk has an Event Manager that notifies the following events: Verk.Events.JobStarted Verk.Events.JobFinished Verk.Events.JobFailed Verk.Events.QueueRunning Verk.Events.QueuePausing Verk.Events.QueuePaused One can define an error tracking handler like this: defmodule TrackingErrorHandler do use GenStage def start_link ( ) do GenStage . start_link ( __MODULE__ , :ok ) end def init ( _ ) do filter = fn event -&gt; event . __struct__ == Verk.Events.JobFailed end { :consumer , :state , subscribe_to : [ { Verk.EventProducer , selector : filter } ] } end def handle_events ( events , _from , state ) do Enum . each ( events , &amp; handle_event / 1 ) { :noreply , [ ] , state } end defp handle_event ( % Verk.Events.JobFailed { job : job , failed_at : failed_at , stacktrace : trace } ) do MyTrackingExceptionSystem . track ( stacktrace : trace , name : job . class ) end end Notice the selector to get just the type JobFailed. If no selector is set every event is sent. Then adding the consumer to your supervision tree: defmodule Example.App do use Application def start ( _type , _args ) do import Supervisor.Spec tree = [ supervisor ( Verk.Supervisor , [ ] ) , worker ( TrackingErrorHandler , [ ] ) ] opts = [ name : Simple.Sup , strategy : :one_for_one ] Supervisor . start_link ( tree , opts ) end end","ref":"readme.html#error-tracking","title":"Overview - Error tracking","type":"extras"},{"doc":"Check Verk Web !","ref":"readme.html#dashboard","title":"Overview - Dashboard ?","type":"extras"},{"doc":"Check Verk Stats","ref":"readme.html#metrics","title":"Overview - Metrics ?","type":"extras"},{"doc":"Copyright (c) 2013 Eduardo Gurgel Pinho Verk is released under the MIT License. See the LICENSE.md file for further details.","ref":"readme.html#license","title":"Overview - License","type":"extras"},{"doc":"Initial development sponsored by Carnival.io","ref":"readme.html#sponsorship","title":"Overview - Sponsorship","type":"extras"}]